Index: src/main/java/hudson/model/Hudson.java
===================================================================
--- src/main/java/hudson/model/Hudson.java	(wersja 31344)
+++ src/main/java/hudson/model/Hudson.java	(kopia robocza)
@@ -26,7 +26,7 @@
 
 import com.thoughtworks.xstream.XStream;
 import hudson.BulkChange;
-import hudson.DNSMultiCast;
+// import hudson.DNSMultiCast;
 import hudson.DescriptorExtensionList;
 import hudson.Extension;
 import hudson.ExtensionList;
@@ -423,7 +423,7 @@
 
     private transient UDPBroadcastThread udpBroadcastThread;
 
-    private transient DNSMultiCast dnsMultiCast;
+    // private transient DNSMultiCast dnsMultiCast;
 
     /**
      * List of registered {@link ItemListener}s.
@@ -625,7 +625,7 @@
 
             udpBroadcastThread = new UDPBroadcastThread(this);
             udpBroadcastThread.start();
-            dnsMultiCast = new DNSMultiCast(this);
+            // dnsMultiCast = new DNSMultiCast(this);
 
             updateComputerList();
 
@@ -2202,8 +2202,8 @@
         }
         if(udpBroadcastThread!=null)
             udpBroadcastThread.shutdown();
-        if(dnsMultiCast!=null)
-            dnsMultiCast.close();
+        // if(dnsMultiCast!=null)
+           // dnsMultiCast.close();
         ExternalJob.reloadThread.interrupt();
         Trigger.timer.cancel();
         // TODO: how to wait for the completion of the last job?
Index: src/main/java/hudson/DNSMultiCast.java
===================================================================
--- src/main/java/hudson/DNSMultiCast.java	(wersja 31344)
+++ src/main/java/hudson/DNSMultiCast.java	(kopia robocza)
@@ -2,8 +2,8 @@
 
 import hudson.model.Hudson;
 
-import javax.jmdns.JmDNS;
-import javax.jmdns.ServiceInfo;
+// import javax.jmdns.JmDNS;
+// import javax.jmdns.ServiceInfo;
 import java.io.Closeable;
 import java.io.IOException;
 import java.util.HashMap;
@@ -17,11 +17,11 @@
  * @author Kohsuke Kawaguchi
  */
 public class DNSMultiCast implements Closeable {
-    private JmDNS jmdns;
+    // private JmDNS jmdns;
 
     public DNSMultiCast(Hudson hudson) {
-        try {
-            this.jmdns = JmDNS.create();
+        /* try {
+            // this.jmdns = JmDNS.create();
 
             Map<String,String> props = new HashMap<String, String>();
             String rootURL = hudson.getRootUrl();
@@ -33,15 +33,15 @@
             if (tal!=null)
                 props.put("slave-port",String.valueOf(tal.getPort()));
 
-            jmdns.registerService(ServiceInfo.create("_hudson._tcp.local.","hudson",
-                    80,0,0,props));
-        } catch (IOException e) {
-            LOGGER.log(Level.WARNING,"Failed to advertise the service to DNS multi-cast",e);
-        }
+            // jmdns.registerService(ServiceInfo.create("_hudson._tcp.local.","hudson",
+            //        80,0,0,props));
+        } catch (IOException e) { */
+            LOGGER.log(Level.WARNING,"Failed to advertise the service to DNS multi-cast");
+        // }
     }
 
     public void close() {
-        jmdns.close();
+        // jmdns.close();
     }
 
     private static final Logger LOGGER = Logger.getLogger(DNSMultiCast.class.getName());
Index: pom.xml
===================================================================
--- pom.xml	(wersja 31344)
+++ pom.xml	(kopia robocza)
@@ -702,11 +702,11 @@
       <artifactId>wstx-asl</artifactId>
       <version>3.2.7</version>
     </dependency>
-    <dependency>
+    <!-- <dependency>
       <groupId>org.jvnet.hudson</groupId>
       <artifactId>jmdns</artifactId>
       <version>3.1.6</version>
-    </dependency>
+    </dependency> -->
     <dependency>
       <groupId>com.sun.winsw</groupId>
       <artifactId>winsw</artifactId>