<html><head><meta name="color-scheme" content="light dark"></head><body><pre style="word-wrap: break-word; white-space: pre-wrap;">Index: pom.xml
===================================================================
--- pom.xml	(revision 33687)
+++ pom.xml	(working copy)
@@ -1,6 +1,7 @@
 &lt;?xml version="1.0" encoding="UTF-8"?&gt;
 &lt;project xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/maven-v4_0_0.xsd"&gt;
   &lt;modelVersion&gt;4.0.0&lt;/modelVersion&gt;
+
   &lt;groupId&gt;org.jvnet.hudson&lt;/groupId&gt;
   &lt;artifactId&gt;hudson&lt;/artifactId&gt;
   &lt;version&gt;1.7&lt;/version&gt;
@@ -8,39 +9,41 @@
 
   &lt;name&gt;Hudson&lt;/name&gt;
   &lt;url&gt;https://hudson.dev.java.net/&lt;/url&gt;
-  
+
   &lt;issueManagement&gt;
-      &lt;system&gt;JIRA&lt;/system&gt;
-      &lt;url&gt;http://issues.hudson-ci.org/secure/Dashboard.jspa&lt;/url&gt;
+    &lt;system&gt;JIRA&lt;/system&gt;
+    &lt;url&gt;http://issues.hudson-ci.org/secure/Dashboard.jspa&lt;/url&gt;
   &lt;/issueManagement&gt;
+
   &lt;ciManagement&gt;
-      &lt;system&gt;Hudson&lt;/system&gt;
-      &lt;url&gt;http://hudson.glassfish.org/job/hudson&lt;/url&gt;
+    &lt;system&gt;Hudson&lt;/system&gt;
+    &lt;url&gt;http://hudson.glassfish.org/job/hudson&lt;/url&gt;
   &lt;/ciManagement&gt;
+
   &lt;mailingLists&gt;
-      &lt;mailingList&gt;
-          &lt;name&gt;Hudson developer discussion list&lt;/name&gt;
-          &lt;subscribe&gt;dev-subscribe@hudson.dev.java.net&lt;/subscribe&gt;
-          &lt;unsubscribe&gt;dev-unsubscribe@hudson.dev.java.net&lt;/unsubscribe&gt;
-          &lt;post&gt;dev@hudson.dev.java.net&lt;/post&gt;
-          &lt;archive&gt;http://www.nabble.com/Hudson-dev-f25543.html&lt;/archive&gt;
-      &lt;/mailingList&gt;
-      &lt;mailingList&gt;
-          &lt;name&gt;Hudson user discussion list&lt;/name&gt;
-          &lt;subscribe&gt;users-subscribe@hudson.dev.java.net&lt;/subscribe&gt;
-          &lt;unsubscribe&gt;users-unsubscribe@hudson.dev.java.net&lt;/unsubscribe&gt;
-          &lt;post&gt;users@hudson.dev.java.net&lt;/post&gt;
-          &lt;archive&gt;http://www.nabble.com/Hudson-users-f16872.html&lt;/archive&gt;
-      &lt;/mailingList&gt;
-      &lt;mailingList&gt;
-          &lt;name&gt;Hudson Japanese user discussion list&lt;/name&gt;
-          &lt;subscribe&gt;ja-subscribe@hudson.dev.java.net&lt;/subscribe&gt;
-          &lt;unsubscribe&gt;ja-unsubscribe@hudson.dev.java.net&lt;/unsubscribe&gt;
-          &lt;post&gt;ja@hudson.dev.java.net&lt;/post&gt;
-          &lt;archive&gt;http://www.nabble.com/Hudson-ja-f29991.html&lt;/archive&gt;
-      &lt;/mailingList&gt;
+    &lt;mailingList&gt;
+      &lt;name&gt;Hudson developer discussion list&lt;/name&gt;
+      &lt;subscribe&gt;dev-subscribe@hudson.dev.java.net&lt;/subscribe&gt;
+      &lt;unsubscribe&gt;dev-unsubscribe@hudson.dev.java.net&lt;/unsubscribe&gt;
+      &lt;post&gt;dev@hudson.dev.java.net&lt;/post&gt;
+      &lt;archive&gt;http://www.nabble.com/Hudson-dev-f25543.html&lt;/archive&gt;
+    &lt;/mailingList&gt;
+    &lt;mailingList&gt;
+      &lt;name&gt;Hudson user discussion list&lt;/name&gt;
+      &lt;subscribe&gt;users-subscribe@hudson.dev.java.net&lt;/subscribe&gt;
+      &lt;unsubscribe&gt;users-unsubscribe@hudson.dev.java.net&lt;/unsubscribe&gt;
+      &lt;post&gt;users@hudson.dev.java.net&lt;/post&gt;
+      &lt;archive&gt;http://www.nabble.com/Hudson-users-f16872.html&lt;/archive&gt;
+    &lt;/mailingList&gt;
+    &lt;mailingList&gt;
+      &lt;name&gt;Hudson Japanese user discussion list&lt;/name&gt;
+      &lt;subscribe&gt;ja-subscribe@hudson.dev.java.net&lt;/subscribe&gt;
+      &lt;unsubscribe&gt;ja-unsubscribe@hudson.dev.java.net&lt;/unsubscribe&gt;
+      &lt;post&gt;ja@hudson.dev.java.net&lt;/post&gt;
+      &lt;archive&gt;http://www.nabble.com/Hudson-ja-f29991.html&lt;/archive&gt;
+    &lt;/mailingList&gt;
   &lt;/mailingLists&gt;
- 
+
   &lt;scm&gt;
     &lt;connection&gt;scm:svn:https://guest@svn.dev.java.net/svn/hudson/trunk/hudson/&lt;/connection&gt;
     &lt;developerConnection&gt;scm:svn:https://svn.dev.java.net/svn/hudson/trunk/hudson/&lt;/developerConnection&gt;
@@ -82,7 +85,8 @@
     &lt;/repository&gt;
     &lt;snapshotRepository&gt;
       &lt;!-- prevent accidental deployment of SNAPSHOTS to repository --&gt;
-      &lt;id&gt;local-repo&lt;/id&gt;&lt;!-- M3 says: "'distributionManagement.snapshotRepository.id' must not be 'local', this identifier is reserved." --&gt;
+      &lt;id&gt;local-repo&lt;/id&gt;
+      &lt;!-- M3 says: "'distributionManagement.snapshotRepository.id' must not be 'local', this identifier is reserved." --&gt;
       &lt;url&gt;file:.&lt;/url&gt;
     &lt;/snapshotRepository&gt;
   &lt;/distributionManagement&gt;
@@ -96,13 +100,11 @@
     &lt;/dependency&gt;
   &lt;/dependencies&gt;
 
-
   &lt;build&gt;
     &lt;plugins&gt;
       &lt;plugin&gt;
-        &lt;groupId&gt;org.apache.maven.plugins&lt;/groupId&gt;
         &lt;artifactId&gt;maven-enforcer-plugin&lt;/artifactId&gt;
-	&lt;version&gt;1.0-beta-1&lt;/version&gt;
+        &lt;version&gt;${maven-enforcer-plugin.version}&lt;/version&gt;
         &lt;executions&gt;
           &lt;execution&gt;
             &lt;phase&gt;validate&lt;/phase&gt;
@@ -114,6 +116,7 @@
       &lt;/plugin&gt;
       &lt;plugin&gt;
         &lt;artifactId&gt;maven-compiler-plugin&lt;/artifactId&gt;
+        &lt;version&gt;${maven-compiler-plugin.version}&lt;/version&gt;
         &lt;configuration&gt;
           &lt;source&gt;1.5&lt;/source&gt;
           &lt;target&gt;1.5&lt;/target&gt;
@@ -121,14 +124,14 @@
       &lt;/plugin&gt;
       &lt;plugin&gt;
         &lt;artifactId&gt;maven-idea-plugin&lt;/artifactId&gt;
-        &lt;version&gt;2.1&lt;/version&gt;
+        &lt;version&gt;${maven-idea-plugin.version}&lt;/version&gt;
         &lt;configuration&gt;
           &lt;jdkName&gt;JDK1.5&lt;/jdkName&gt;
         &lt;/configuration&gt;
       &lt;/plugin&gt;
       &lt;plugin&gt;
         &lt;artifactId&gt;maven-eclipse-plugin&lt;/artifactId&gt;
-        &lt;version&gt;2.7&lt;/version&gt;
+        &lt;version&gt;${maven-eclipse-plugin.version}&lt;/version&gt;
       &lt;/plugin&gt;
     &lt;/plugins&gt;
     &lt;extensions&gt;
@@ -138,6 +141,198 @@
         &lt;version&gt;1.8&lt;/version&gt;
       &lt;/extension&gt;
     &lt;/extensions&gt;
+    &lt;pluginManagement&gt;
+      &lt;plugins&gt;
+        &lt;plugin&gt;
+          &lt;artifactId&gt;maven-assembly-plugin&lt;/artifactId&gt;
+          &lt;version&gt;${maven-assembly-plugin.version}&lt;/version&gt;
+        &lt;/plugin&gt;
+        &lt;plugin&gt;
+          &lt;artifactId&gt;maven-changelog-plugin&lt;/artifactId&gt;
+          &lt;version&gt;${maven-changelog-plugin.version}&lt;/version&gt;
+        &lt;/plugin&gt;
+        &lt;plugin&gt;
+          &lt;artifactId&gt;maven-checkstyle-plugin&lt;/artifactId&gt;
+          &lt;version&gt;${maven-checkstyle-plugin.version}&lt;/version&gt;
+        &lt;/plugin&gt;
+        &lt;plugin&gt;
+          &lt;artifactId&gt;maven-clean-plugin&lt;/artifactId&gt;
+          &lt;version&gt;${maven-clean-plugin.version}&lt;/version&gt;
+        &lt;/plugin&gt;
+        &lt;plugin&gt;
+          &lt;artifactId&gt;maven-compiler-plugin&lt;/artifactId&gt;
+          &lt;version&gt;${maven-compiler-plugin.version}&lt;/version&gt;
+        &lt;/plugin&gt;
+        &lt;plugin&gt;
+          &lt;artifactId&gt;maven-dependency-plugin&lt;/artifactId&gt;
+          &lt;version&gt;${maven-dependency-plugin.version}&lt;/version&gt;
+        &lt;/plugin&gt;
+        &lt;plugin&gt;
+          &lt;artifactId&gt;maven-deploy-plugin&lt;/artifactId&gt;
+          &lt;version&gt;${maven-deploy-plugin.version}&lt;/version&gt;
+        &lt;/plugin&gt;
+        &lt;plugin&gt;
+          &lt;artifactId&gt;maven-doap-plugin&lt;/artifactId&gt;
+          &lt;version&gt;${maven-doap-plugin.version}&lt;/version&gt;
+        &lt;/plugin&gt;
+        &lt;plugin&gt;
+          &lt;artifactId&gt;maven-eclipse-plugin&lt;/artifactId&gt;
+          &lt;version&gt;${maven-eclipse-plugin.version}&lt;/version&gt;
+        &lt;/plugin&gt;
+        &lt;plugin&gt;
+          &lt;artifactId&gt;maven-enforcer-plugin&lt;/artifactId&gt;
+          &lt;version&gt;${maven-enforcer-plugin.version}&lt;/version&gt;
+        &lt;/plugin&gt;
+        &lt;plugin&gt;
+          &lt;artifactId&gt;maven-help-plugin&lt;/artifactId&gt;
+          &lt;version&gt;${maven-help-plugin.version}&lt;/version&gt;
+        &lt;/plugin&gt;
+        &lt;plugin&gt;
+          &lt;artifactId&gt;maven-idea-plugin&lt;/artifactId&gt;
+          &lt;version&gt;${maven-idea-plugin.version}&lt;/version&gt;
+        &lt;/plugin&gt;
+        &lt;plugin&gt;
+          &lt;artifactId&gt;maven-install-plugin&lt;/artifactId&gt;
+          &lt;version&gt;${maven-install-plugin.version}&lt;/version&gt;
+        &lt;/plugin&gt;
+        &lt;plugin&gt;
+          &lt;artifactId&gt;maven-jar-plugin&lt;/artifactId&gt;
+          &lt;version&gt;${maven-jar-plugin.version}&lt;/version&gt;
+        &lt;/plugin&gt;
+        &lt;plugin&gt;
+          &lt;artifactId&gt;maven-javadoc-plugin&lt;/artifactId&gt;
+          &lt;version&gt;${maven-javadoc-plugin.version}&lt;/version&gt;
+        &lt;/plugin&gt;
+        &lt;plugin&gt;
+          &lt;artifactId&gt;maven-jxr-plugin&lt;/artifactId&gt;
+          &lt;version&gt;${maven-jxr-plugin.version}&lt;/version&gt;
+        &lt;/plugin&gt;
+        &lt;plugin&gt;
+          &lt;artifactId&gt;maven-pmd-plugin&lt;/artifactId&gt;
+          &lt;version&gt;${maven-pmd-plugin.version}&lt;/version&gt;
+        &lt;/plugin&gt;
+        &lt;plugin&gt;
+          &lt;artifactId&gt;maven-project-info-reports-plugin&lt;/artifactId&gt;
+          &lt;version&gt;${maven-project-info-reports-plugin.version}&lt;/version&gt;
+        &lt;/plugin&gt;
+        &lt;plugin&gt;
+          &lt;artifactId&gt;maven-reactor-plugin&lt;/artifactId&gt;
+          &lt;version&gt;${maven-reactor-plugin.version}&lt;/version&gt;
+        &lt;/plugin&gt;
+        &lt;plugin&gt;
+          &lt;artifactId&gt;maven-release-plugin&lt;/artifactId&gt;
+          &lt;version&gt;${maven-release-plugin.version}&lt;/version&gt;
+        &lt;/plugin&gt;
+        &lt;plugin&gt;
+          &lt;artifactId&gt;maven-remote-resources-plugin&lt;/artifactId&gt;
+          &lt;version&gt;${maven-remote-resources-plugin.version}&lt;/version&gt;
+        &lt;/plugin&gt;
+        &lt;plugin&gt;
+          &lt;artifactId&gt;maven-resources-plugin&lt;/artifactId&gt;
+          &lt;version&gt;${maven-resources-plugin.version}&lt;/version&gt;
+        &lt;/plugin&gt;
+        &lt;plugin&gt;
+          &lt;artifactId&gt;maven-site-plugin&lt;/artifactId&gt;
+          &lt;version&gt;${maven-site-plugin.version}&lt;/version&gt;
+        &lt;/plugin&gt;
+        &lt;plugin&gt;
+          &lt;artifactId&gt;maven-source-plugin&lt;/artifactId&gt;
+          &lt;version&gt;${maven-source-plugin.version}&lt;/version&gt;
+        &lt;/plugin&gt;
+        &lt;plugin&gt;
+          &lt;artifactId&gt;maven-surefire-plugin&lt;/artifactId&gt;
+          &lt;version&gt;${maven-surefire-plugin.version}&lt;/version&gt;
+        &lt;/plugin&gt;
+        &lt;plugin&gt;
+          &lt;artifactId&gt;maven-surefire-report-plugin&lt;/artifactId&gt;
+          &lt;version&gt;${maven-surefire-report-plugin.version}&lt;/version&gt;
+        &lt;/plugin&gt;
+        &lt;plugin&gt;
+          &lt;artifactId&gt;maven-war-plugin&lt;/artifactId&gt;
+          &lt;version&gt;${maven-war-plugin.version}&lt;/version&gt;
+        &lt;/plugin&gt;
+        &lt;plugin&gt;
+          &lt;groupId&gt;org.codehaus.mojo&lt;/groupId&gt;
+          &lt;artifactId&gt;apt-maven-plugin&lt;/artifactId&gt;
+          &lt;version&gt;${apt-maven-plugin.version}&lt;/version&gt;
+        &lt;/plugin&gt;
+        &lt;plugin&gt;
+          &lt;groupId&gt;org.codehaus.mojo&lt;/groupId&gt;
+          &lt;artifactId&gt;axistools-maven-plugin&lt;/artifactId&gt;
+          &lt;version&gt;${axistools-maven-plugin.version}&lt;/version&gt;
+        &lt;/plugin&gt;
+        &lt;plugin&gt;
+          &lt;groupId&gt;org.codehaus.mojo&lt;/groupId&gt;
+          &lt;artifactId&gt;buildnumber-maven-plugin&lt;/artifactId&gt;
+          &lt;version&gt;${buildnumber-maven-plugin.version}&lt;/version&gt;
+        &lt;/plugin&gt;
+        &lt;plugin&gt;
+          &lt;groupId&gt;org.codehaus.mojo&lt;/groupId&gt;
+          &lt;artifactId&gt;build-helper-maven-plugin&lt;/artifactId&gt;
+          &lt;version&gt;${build-helper-maven-plugin.version}&lt;/version&gt;
+        &lt;/plugin&gt;
+        &lt;plugin&gt;
+          &lt;groupId&gt;org.codehaus.cargo&lt;/groupId&gt;
+          &lt;artifactId&gt;cargo-maven2-plugin&lt;/artifactId&gt;
+          &lt;version&gt;${cargo-maven2-plugin.version}&lt;/version&gt;
+        &lt;/plugin&gt;
+        &lt;plugin&gt;
+          &lt;groupId&gt;org.codehaus.mojo&lt;/groupId&gt;
+          &lt;artifactId&gt;cobertura-maven-plugin&lt;/artifactId&gt;
+          &lt;version&gt;${cobertura-maven-plugin.version}&lt;/version&gt;
+        &lt;/plugin&gt;
+        &lt;plugin&gt;
+          &lt;groupId&gt;org.codehaus.mojo&lt;/groupId&gt;
+          &lt;artifactId&gt;exec-maven-plugin&lt;/artifactId&gt;
+          &lt;version&gt;${exec-maven-plugin.version}&lt;/version&gt;
+        &lt;/plugin&gt;
+        &lt;plugin&gt;
+          &lt;groupId&gt;org.codehaus.mojo&lt;/groupId&gt;
+          &lt;artifactId&gt;findbugs-maven-plugin&lt;/artifactId&gt;
+          &lt;version&gt;${findbugs-maven-plugin.version}&lt;/version&gt;
+        &lt;/plugin&gt;
+        &lt;plugin&gt;
+          &lt;groupId&gt;org.codehaus.mojo&lt;/groupId&gt;
+          &lt;artifactId&gt;gwt-maven-plugin&lt;/artifactId&gt;
+          &lt;version&gt;${gwt-maven-plugin.version}&lt;/version&gt;
+        &lt;/plugin&gt;
+        &lt;plugin&gt;
+          &lt;groupId&gt;org.codehaus.mojo&lt;/groupId&gt;
+          &lt;artifactId&gt;javancss-maven-plugin&lt;/artifactId&gt;
+          &lt;version&gt;${javancss-maven-plugin.version}&lt;/version&gt;
+        &lt;/plugin&gt;
+        &lt;plugin&gt;
+          &lt;groupId&gt;org.codehaus.mojo&lt;/groupId&gt;
+          &lt;artifactId&gt;jdepend-maven-plugin&lt;/artifactId&gt;
+          &lt;version&gt;${jdepend-maven-plugin.version}&lt;/version&gt;
+        &lt;/plugin&gt;
+        &lt;plugin&gt;
+          &lt;groupId&gt;org.codehaus.mojo&lt;/groupId&gt;
+          &lt;artifactId&gt;openjpa-maven-plugin&lt;/artifactId&gt;
+          &lt;version&gt;${openjpa-maven-plugin.version}&lt;/version&gt;
+        &lt;/plugin&gt;
+        &lt;plugin&gt;
+          &lt;groupId&gt;org.codehaus.mojo&lt;/groupId&gt;
+          &lt;artifactId&gt;taglist-maven-plugin&lt;/artifactId&gt;
+          &lt;version&gt;${taglist-maven-plugin.version}&lt;/version&gt;
+        &lt;/plugin&gt;
+        &lt;plugin&gt;
+          &lt;groupId&gt;org.codehaus.mojo&lt;/groupId&gt;
+          &lt;artifactId&gt;versions-maven-plugin&lt;/artifactId&gt;
+          &lt;version&gt;${versions-maven-plugin.version}&lt;/version&gt;
+        &lt;/plugin&gt;
+        &lt;plugin&gt;
+          &lt;groupId&gt;org.codehaus.mojo&lt;/groupId&gt;
+          &lt;artifactId&gt;xml-maven-plugin&lt;/artifactId&gt;
+          &lt;version&gt;${xml-maven-plugin.version}&lt;/version&gt;
+        &lt;/plugin&gt;
+        &lt;plugin&gt;
+          &lt;groupId&gt;org.mortbay.jetty&lt;/groupId&gt;
+          &lt;artifactId&gt;maven-jetty-plugin&lt;/artifactId&gt;
+          &lt;version&gt;${maven-jetty-plugin.version}&lt;/version&gt;
+        &lt;/plugin&gt;
+      &lt;/plugins&gt;
+    &lt;/pluginManagement&gt;
   &lt;/build&gt;
 
   &lt;modules&gt;
@@ -146,7 +341,7 @@
     &lt;module&gt;plugins&lt;/module&gt;
     &lt;module&gt;pxeboot&lt;/module&gt;
   &lt;/modules&gt;
-  
+
   &lt;profiles&gt;
     &lt;profile&gt;
       &lt;id&gt;always-check-remote-repositories&lt;/id&gt;
@@ -155,11 +350,59 @@
       &lt;/properties&gt;
     &lt;/profile&gt;
   &lt;/profiles&gt;
+
   &lt;properties&gt;
     &lt;!-- by default only check remote repositories once per week --&gt;
     &lt;maven.repository.update.freqency&gt;interval:10080&lt;/maven.repository.update.freqency&gt;
 
     &lt;!-- the version of Maven that we embed in Hudson --&gt;
     &lt;maven.version&gt;2.0.4&lt;/maven.version&gt;
+
+    &lt;!-- define all plugin versions as properties so individual hierarchies can easily override --&gt;
+    &lt;maven-antrun-plugin.version&gt;1.3&lt;/maven-antrun-plugin.version&gt;
+    &lt;maven-assembly-plugin.version&gt;2.2-beta-5&lt;/maven-assembly-plugin.version&gt;
+    &lt;maven-changelog-plugin.version&gt;2.1&lt;/maven-changelog-plugin.version&gt;
+    &lt;maven-checkstyle-plugin.version&gt;2.5&lt;/maven-checkstyle-plugin.version&gt;
+    &lt;maven-clean-plugin.version&gt;2.4.1&lt;/maven-clean-plugin.version&gt;
+    &lt;maven-compiler-plugin.version&gt;2.3.1&lt;/maven-compiler-plugin.version&gt;
+    &lt;maven-dependency-plugin.version&gt;2.1&lt;/maven-dependency-plugin.version&gt;
+    &lt;maven-deploy-plugin.version&gt;2.5&lt;/maven-deploy-plugin.version&gt;
+    &lt;maven-doap-plugin.version&gt;1.0&lt;/maven-doap-plugin.version&gt;
+    &lt;maven-eclipse-plugin.version&gt;2.7&lt;/maven-eclipse-plugin.version&gt;
+    &lt;maven-enforcer-plugin.version&gt;1.0-beta-1&lt;/maven-enforcer-plugin.version&gt;
+    &lt;maven-help-plugin.version&gt;2.1.1&lt;/maven-help-plugin.version&gt;
+    &lt;maven-idea-plugin.version&gt;2.1&lt;/maven-idea-plugin.version&gt;
+    &lt;maven-install-plugin.version&gt;2.3.1&lt;/maven-install-plugin.version&gt;
+    &lt;maven-javadoc-plugin.version&gt;2.6.1&lt;/maven-javadoc-plugin.version&gt;
+    &lt;maven-jar-plugin.version&gt;2.3.1&lt;/maven-jar-plugin.version&gt;
+    &lt;maven-jetty-plugin.version&gt;6.1.23&lt;/maven-jetty-plugin.version&gt;
+    &lt;maven-jxr-plugin.version&gt;2.1&lt;/maven-jxr-plugin.version&gt;
+    &lt;maven-pmd-plugin.version&gt;2.4&lt;/maven-pmd-plugin.version&gt;
+    &lt;maven-project-info-reports-plugin.version&gt;2.1.2&lt;/maven-project-info-reports-plugin.version&gt;
+    &lt;maven-reactor-plugin.version&gt;1.0&lt;/maven-reactor-plugin.version&gt;
+    &lt;maven-release-plugin.version&gt;2.0&lt;/maven-release-plugin.version&gt;
+    &lt;maven-remote-resources-plugin.version&gt;1.1&lt;/maven-remote-resources-plugin.version&gt;
+    &lt;maven-resources-plugin.version&gt;2.4.3&lt;/maven-resources-plugin.version&gt;
+    &lt;maven-site-plugin.version&gt;2.1&lt;/maven-site-plugin.version&gt;
+    &lt;!-- Do not go to 2.1.2: http://jira.codehaus.org/browse/MSOURCES-30 --&gt;
+    &lt;maven-source-plugin.version&gt;2.1.1&lt;/maven-source-plugin.version&gt;
+    &lt;maven-surefire-plugin.version&gt;2.5&lt;/maven-surefire-plugin.version&gt;
+    &lt;maven-surefire-report-plugin.version&gt;2.5&lt;/maven-surefire-report-plugin.version&gt;
+    &lt;maven-war-plugin.version&gt;2.1-beta-1&lt;/maven-war-plugin.version&gt;
+    &lt;apt-maven-plugin.version&gt;1.0-alpha-3&lt;/apt-maven-plugin.version&gt;
+    &lt;axistools-maven-plugin.version&gt;1.3&lt;/axistools-maven-plugin.version&gt;
+    &lt;buildnumber-maven-plugin.version&gt;1.0-beta-4&lt;/buildnumber-maven-plugin.version&gt;
+    &lt;build-helper-maven-plugin.version&gt;1.5&lt;/build-helper-maven-plugin.version&gt;
+    &lt;cargo-maven2-plugin.version&gt;1.0.1-alpha-2&lt;/cargo-maven2-plugin.version&gt;
+    &lt;cobertura-maven-plugin.version&gt;2.3&lt;/cobertura-maven-plugin.version&gt;
+    &lt;exec-maven-plugin.version&gt;1.2&lt;/exec-maven-plugin.version&gt;
+    &lt;findbugs-maven-plugin.version&gt;2.3.1&lt;/findbugs-maven-plugin.version&gt;
+    &lt;gwt-maven-plugin.version&gt;1.2&lt;/gwt-maven-plugin.version&gt;
+    &lt;javancss-maven-plugin.version&gt;2.0&lt;/javancss-maven-plugin.version&gt;
+    &lt;jdepend-maven-plugin.version&gt;2.0-beta-2&lt;/jdepend-maven-plugin.version&gt;
+    &lt;openjpa-maven-plugin.version&gt;1.1&lt;/openjpa-maven-plugin.version&gt;
+    &lt;taglist-maven-plugin.version&gt;2.4&lt;/taglist-maven-plugin.version&gt;
+    &lt;versions-maven-plugin.version&gt;1.1&lt;/versions-maven-plugin.version&gt;
+    &lt;xml-maven-plugin.version&gt;1.0-beta-3&lt;/xml-maven-plugin.version&gt;
   &lt;/properties&gt;
 &lt;/project&gt;
</pre></body></html>